Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn.F90	(revision 3211)
@@ -45,4 +45,9 @@
    REAL(wp) ::   rtaue  , rtauw  , rtaun  , rtaus  ,  &
                  rtauein, rtauwin, rtaunin, rtausin
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !!---------------------------------------------------------------------------------
@@ -147,7 +152,13 @@
          ! 1.1 U zonal velocity    
          ! --------------------
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = nie0, nie1
+               DO jk = 1, jpkm1
+#else
          DO ji = nie0, nie1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) * (1.-uemsk(jj,jk)) + &
                                  uemsk(jj,jk)*ufoe(jj,jk)
@@ -158,7 +169,13 @@
          ! 1.2 V meridional velocity
          ! -------------------------
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = nie0+1, nie1+1
+               DO jk = 1, jpkm1
+#else
          DO ji = nie0+1, nie1+1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   va(ji,jj,jk) = va(ji,jj,jk) * (1.-vemsk(jj,jk)) + &
                                  vfoe(jj,jk)*vemsk(jj,jk)
@@ -191,7 +208,13 @@
          ! ... radiative conditions on the total part + relaxation toward climatology
          ! ... (jpjedp1, jpjefm1),jpieob
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = nie0, nie1
+               DO jk = 1, jpkm1
+#else
          DO ji = nie0, nie1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   z05cx = u_cxebnd(jj,jk)
                   z05cx = z05cx / e1t(ji,jj)
@@ -229,7 +252,13 @@
          ! ... radiative condition
          ! ... (jpjedp1, jpjefm1), jpieob+1
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = nie0+1, nie1+1
+               DO jk = 1, jpkm1
+#else
          DO ji = nie0+1, nie1+1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   z05cx = v_cxebnd(jj,jk) 
                   z05cx = z05cx / e1f(ji-1,jj)
@@ -289,7 +318,13 @@
          ! 1.1 U zonal velocity
          ! ---------------------
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = niw0, niw1
+               DO jk = 1, jpkm1
+#else
          DO ji = niw0, niw1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) * (1.-uwmsk(jj,jk)) + &
                                  uwmsk(jj,jk)*ufow(jj,jk)
@@ -300,7 +335,13 @@
          ! 1.2 V meridional velocity
          ! -------------------------
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = niw0, niw1
+               DO jk = 1, jpkm1
+#else
          DO ji = niw0, niw1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   va(ji,jj,jk) = va(ji,jj,jk) * (1.-vwmsk(jj,jk)) + &
                                  vfow(jj,jk)*vwmsk(jj,jk)
@@ -333,7 +374,13 @@
          ! ... radiative conditions on the total part + relaxation toward climatology
          ! ... (jpjwdp1, jpjwfm1), jpiwob
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = niw0, niw1
+               DO jk = 1, jpkm1
+#else
          DO ji = niw0, niw1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   z05cx = u_cxwbnd(jj,jk)
                   z05cx = z05cx / e1t(ji+1,jj)
@@ -370,7 +417,13 @@
          ! ... radiative condition plus Raymond-Kuo
          ! ... (jpjwdp1, jpjwfm1),jpiwob
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = niw0, niw1
+               DO jk = 1, jpkm1
+#else
          DO ji = niw0, niw1
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   z05cx = v_cxwbnd(jj,jk)  
                   z05cx = z05cx / e1f(ji,jj)
@@ -429,6 +482,11 @@
          ! --------------------
          DO jj = njn0+1, njn1+1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   ua(ji,jj,jk)= ua(ji,jj,jk) * (1.-unmsk(ji,jk)) + &
                                 ufon(ji,jk)*unmsk(ji,jk)
@@ -440,6 +498,11 @@
          ! -------------------------
          DO jj = njn0, njn1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   va(ji,jj,jk)= va(ji,jj,jk) * (1.-vnmsk(ji,jk)) + &
                                 vfon(ji,jk)*vnmsk(ji,jk)
@@ -474,6 +537,11 @@
          ! ... jpjnob+1,(jpindp1, jpinfm1)
          DO jj = njn0+1, njn1+1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   z05cx= u_cynbnd(ji,jk) 
                   z05cx = z05cx / e2f(ji, jj-1)
@@ -518,6 +586,11 @@
          ! ... jpjnob,(jpindp1, jpinfm1)
          DO jj = njn0, njn1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
          ! ... 2* gradj(v) (T-point i=nibm, time mean)
                   z05cx = v_cynbnd(ji,jk)
@@ -580,6 +653,11 @@
          ! --------------------
          DO jj = njs0, njs1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   ua(ji,jj,jk)= ua(ji,jj,jk) * (1.-usmsk(ji,jk)) + &
                                 usmsk(ji,jk) * ufos(ji,jk)
@@ -591,6 +669,11 @@
          ! -------------------------
          DO jj = njs0, njs1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   va(ji,jj,jk)= va(ji,jj,jk) * (1.-vsmsk(ji,jk)) + &
                                 vsmsk(ji,jk) * vfos(ji,jk)
@@ -624,6 +707,11 @@
          ! ... jpjsob,(jpisdp1, jpisfm1)
          DO jj = njs0, njs1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   z05cx= u_cysbnd(ji,jk) 
                   z05cx = z05cx / e2f(ji, jj)
@@ -665,6 +753,11 @@
          ! ... jpjsob,(jpisdp1,jpisfm1)
          DO jj = njs0, njs1
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   z05cx = v_cysbnd(ji,jk)
                   z05cx = z05cx / e2t(ji,jj+1)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90	(revision 3211)
@@ -32,4 +32,9 @@
 
    PUBLIC   obc_dyn_bt  ! routine called in dynnxt (explicit free surface case)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -92,7 +97,13 @@
       !!----------------------------------------------------------------------
 
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = nie0, nie1
+            DO jk = 1, jpkm1
+#else
       DO ji = nie0, nie1
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
                ua(ji,jj,jk) = ua(ji,jj,jk) + sqrt( grav*hur (ji,jj) )               &
                   &                      * ( ( sshn(ji,jj) + sshn(ji+1,jj) ) * 0.5  &
@@ -123,6 +134,11 @@
       !
       DO ji = niw0, niw1
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
                ua(ji,jj,jk) = ua(ji,jj,jk) - sqrt( grav*hur (ji,jj) )               &
                   &                      * ( ( sshn(ji,jj) + sshn(ji+1,jj) ) * 0.5  &
@@ -151,6 +167,11 @@
       !
       DO jj = njn0, njn1
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
                va(ji,jj,jk) = va(ji,jj,jk) + sqrt( grav*hvr (ji,jj) )               &
                   &                      * ( ( sshn(ji,jj) + sshn(ji,jj+1) ) * 0.5  &
@@ -181,6 +202,11 @@
       !
       DO jj = njs0, njs1
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
                va(ji,jj,jk) = va(ji,jj,jk) - sqrt( grav*hvr (ji,jj) )               &
                   &                       * ( ( sshn(ji,jj) + sshn(ji,jj+1) ) * 0.5 &
@@ -209,13 +235,24 @@
       !!----------------------------------------------------------------------
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = nie0, nie1
+             DO jk = 1, jpkm1
+#else
       DO ji = nie0, nie1
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
                ua(ji,jj,jk) = ( ua(ji,jj,jk) + sshfoe_b(ji,jj) ) * uemsk(jj,jk)
             END DO
          END DO
       END DO
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = nie0p1, nie1p1
+#else
       DO ji = nie0p1, nie1p1
          DO jj = 1, jpj
+#endif
             sshn(ji,jj) = sshn(ji,jj) * (1.-temsk(jj,1)) + temsk(jj,1)*sshn_b(ji,jj)
          END DO
@@ -236,4 +273,18 @@
       !!----------------------------------------------------------------------
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = niw0, niw1
+            DO jk = 1, jpkm1
+               ua(ji,jj,jk) = ( ua(ji,jj,jk) + sshfow_b(ji,jj) ) * uwmsk(jj,jk)
+            END DO
+         END DO
+      END DO
+      DO jj = 1, jpj
+         DO ji = niw0, niw1
+            sshn(ji,jj) = sshn(ji,jj) * (1.-twmsk(jj,1)) + twmsk(jj,1)*sshn_b(ji,jj)
+         END DO
+      END DO
+#else
       DO ji = niw0, niw1
          DO jk = 1, jpkm1
@@ -246,4 +297,5 @@
          END DO
       END DO
+#endif
       !
    END SUBROUTINE obc_dyn_bt_west
@@ -262,7 +314,13 @@
       !!----------------------------------------------------------------------
       !
+#if defined key_z_first
       DO jj = njn0, njn1
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
+      DO jj = njn0, njn1
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
                va(ji,jj,jk) = ( va(ji,jj,jk) + sshfon_b(ji,jj) ) * vnmsk(jj,jk)
             END DO
@@ -291,6 +349,11 @@
       !
       DO jj = njs0, njs1
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
                va(ji,jj,jk) = ( va(ji,jj,jk) + sshfos_b(ji,jj) ) * vsmsk(jj,jk)
             END DO
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90	(revision 3211)
@@ -30,4 +30,9 @@
 
    PUBLIC   obc_fla_ts   ! routine called in dynspg_ts (free surface time splitting case)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 3211)
@@ -28,4 +28,9 @@
 
    PUBLIC   obc_init   ! routine called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90	(revision 3211)
@@ -35,4 +35,9 @@
       nitm  = 2,   & ! nitm   = before
       nitm2 = 3      ! nitm2  = before-before
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -114,6 +119,11 @@
 
          ! ... advance in time (time filter, array swap) 
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
                uebnd(jj,jk,nib  ,nitm2) = uebnd(jj,jk,nib  ,nitm)*uemsk(jj,jk)
                uebnd(jj,jk,nibm ,nitm2) = uebnd(jj,jk,nibm ,nitm)*uemsk(jj,jk)
@@ -159,6 +169,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
          ! ... fields nitm2 <== nitm
                vebnd(jj,jk,nib  ,nitm2) = vebnd(jj,jk,nib  ,nitm)*vemsk(jj,jk)
@@ -169,6 +184,11 @@
 
          DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   vebnd(jj,jk,nib  ,nitm) = vebnd(jj,jk,nib,  nit)*vemsk(jj,jk)
                   vebnd(jj,jk,nibm ,nitm) = vebnd(jj,jk,nibm ,nit)*vemsk(jj,jk)
@@ -201,6 +221,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
          ! ... fields nitm <== nit  plus time filter at the boundary
                tebnd(jj,jk,nib,nitm) = tebnd(jj,jk,nib,nit)*temsk(jj,jk)
@@ -210,6 +235,11 @@
 
          DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   tebnd(jj,jk,nibm,nitm) = tebnd(jj,jk,nibm,nit)*temsk(jj,jk)
                   sebnd(jj,jk,nibm,nitm) = sebnd(jj,jk,nibm,nit)*temsk(jj,jk)
@@ -266,6 +296,11 @@
          ! ... (jpjedp1, jpjefm1),jpieob
          DO ji = fs_nie0, fs_nie1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... 2* gradi(u) (T-point i=nibm, time mean)
                   z2dx = ( uebnd(jj,jk,nibm ,nit) + uebnd(jj,jk,nibm ,nitm2) &
@@ -302,6 +337,11 @@
          ! ... (jpjedp1, jpjefm1), jpieob+1
          DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... 2* i-gradient of v (f-point i=nibm, time mean)
                   z2dx = ( vebnd(jj,jk,nibm ,nit) + vebnd(jj,jk,nibm ,nitm2) &
@@ -378,6 +418,11 @@
 
          ! ... advance in time (time filter, array swap) 
+#if defined key_z_first
+         DO jj = 1, jpj 
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj 
+#endif
                uwbnd(jj,jk,nib  ,nitm2) = uwbnd(jj,jk,nib  ,nitm)*uwmsk(jj,jk)
                uwbnd(jj,jk,nibm ,nitm2) = uwbnd(jj,jk,nibm ,nitm)*uwmsk(jj,jk)
@@ -388,6 +433,11 @@
          ! ... fields nitm <== nit  plus time filter at the boundary 
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   uwbnd(jj,jk,nib  ,nitm) = uwbnd(jj,jk,nib  ,nit)*uwmsk(jj,jk)
                   uwbnd(jj,jk,nibm ,nitm) = uwbnd(jj,jk,nibm ,nit)*uwmsk(jj,jk)
@@ -425,6 +475,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
          DO jk = 1, jpkm1
             DO jj = 1, jpj 
+#else
+         DO jj = 1, jpj 
+            DO jk = 1, jpkm1
+#endif
          ! ... fields nitm2 <== nitm
                   vwbnd(jj,jk,nib  ,nitm2) = vwbnd(jj,jk,nib  ,nitm)*vwmsk(jj,jk)
@@ -435,6 +490,11 @@
 
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   vwbnd(jj,jk,nib  ,nitm) = vwbnd(jj,jk,nib,  nit)*vwmsk(jj,jk)
                   vwbnd(jj,jk,nibm ,nitm) = vwbnd(jj,jk,nibm ,nit)*vwmsk(jj,jk)
@@ -467,6 +527,11 @@
  
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
+#endif
          ! ... fields nitm <== nit  plus time filter at the boundary
                twbnd(jj,jk,nib,nitm) = twbnd(jj,jk,nib,nit)*twmsk(jj,jk)
@@ -476,6 +541,11 @@
  
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   twbnd(jj,jk,nibm ,nitm) = twbnd(jj,jk,nibm ,nit)*twmsk(jj,jk)
                   swbnd(jj,jk,nibm ,nitm) = swbnd(jj,jk,nibm ,nit)*twmsk(jj,jk)
@@ -534,6 +604,11 @@
          ! ... (jpjwdp1, jpjwfm1), jpiwob
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... 2* gradi(u) (T-point i=nibm, time mean)
                   z2dx = ( - uwbnd(jj,jk,nibm ,nit) -  uwbnd(jj,jk,nibm ,nitm2) &
@@ -571,6 +646,11 @@
          ! ... (jpjwdp1, jpjwfm1),jpiwob
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... 2* i-gradient of v (f-point i=nibm, time mean)
                   z2dx = ( - vwbnd(jj,jk,nibm ,nit) - vwbnd(jj,jk,nibm ,nitm2) &
@@ -647,6 +727,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm2 <== nitm
                unbnd(ji,jk,nib  ,nitm2) = unbnd(ji,jk,nib  ,nitm)*unmsk(ji,jk)
@@ -657,6 +742,11 @@
 
          DO jj = fs_njn0+1, fs_njn1+1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   unbnd(ji,jk,nib  ,nitm) = unbnd(ji,jk,nib,  nit)*unmsk(ji,jk)
                   unbnd(ji,jk,nibm ,nitm) = unbnd(ji,jk,nibm ,nit)*unmsk(ji,jk)
@@ -689,6 +779,11 @@
 
          ! ... advance in time (time filter, array swap) 
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm2 <== nitm 
                vnbnd(ji,jk,nib  ,nitm2) = vnbnd(ji,jk,nib  ,nitm)*vnmsk(ji,jk)
@@ -699,6 +794,11 @@
 
          DO jj = fs_njn0, fs_njn1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   vnbnd(ji,jk,nib  ,nitm) = vnbnd(ji,jk,nib,  nit)*vnmsk(ji,jk)
                   vnbnd(ji,jk,nibm ,nitm) = vnbnd(ji,jk,nibm ,nit)*vnmsk(ji,jk)
@@ -736,6 +836,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm <== nit  plus time filter at the boundary
                tnbnd(ji,jk,nib ,nitm) = tnbnd(ji,jk,nib,nit)*tnmsk(ji,jk)
@@ -745,6 +850,11 @@
 
          DO jj = fs_njn0+1, fs_njn1+1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   tnbnd(ji,jk,nibm ,nitm) = tnbnd(ji,jk,nibm ,nit)*tnmsk(ji,jk)
                   snbnd(ji,jk,nibm ,nitm) = snbnd(ji,jk,nibm ,nit)*tnmsk(ji,jk)
@@ -803,6 +913,11 @@
          ! ... jpjnob+1,(jpindp1, jpinfm1)
          DO jj = fs_njn0+1, fs_njn1+1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          ! ... 2* j-gradient of u (f-point i=nibm, time mean)
                   z2dx = ( unbnd(ji,jk,nibm ,nit) + unbnd(ji,jk,nibm ,nitm2) &
@@ -860,6 +975,11 @@
          ! ... jpjnob,(jpindp1, jpinfm1)
          DO jj = fs_njn0, fs_njn1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          ! ... 2* gradj(v) (T-point i=nibm, time mean)
                   ii = ji -1 + nimpp
@@ -921,6 +1041,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm2 <== nitm
                   usbnd(ji,jk,nib  ,nitm2) = usbnd(ji,jk,nib  ,nitm)*usmsk(ji,jk)
@@ -931,6 +1056,11 @@
  
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   usbnd(ji,jk,nib  ,nitm) = usbnd(ji,jk,nib,  nit)*usmsk(ji,jk)
                   usbnd(ji,jk,nibm ,nitm) = usbnd(ji,jk,nibm ,nit)*usmsk(ji,jk)
@@ -963,6 +1093,11 @@
  
          !.. advance in time (time filter, array swap) 
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm2 <== nitm 
                vsbnd(ji,jk,nib  ,nitm2) = vsbnd(ji,jk,nib  ,nitm)*vsmsk(ji,jk)
@@ -972,6 +1107,11 @@
 
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   vsbnd(ji,jk,nib  ,nitm) = vsbnd(ji,jk,nib,  nit)*vsmsk(ji,jk)
                   vsbnd(ji,jk,nibm ,nitm) = vsbnd(ji,jk,nibm ,nit)*vsmsk(ji,jk)
@@ -1008,6 +1148,11 @@
 
          ! ... advance in time (time filter, array swap)
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO ji = 1, jpi
+#endif
          ! ... fields nitm <== nit  plus time filter at the boundary
                tsbnd(ji,jk,nib,nitm) = tsbnd(ji,jk,nib,nit)*tsmsk(ji,jk)
@@ -1017,6 +1162,11 @@
 
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   tsbnd(ji,jk,nibm ,nitm) = tsbnd(ji,jk,nibm ,nit)*tsmsk(ji,jk)
                   ssbnd(ji,jk,nibm ,nitm) = ssbnd(ji,jk,nibm ,nit)*tsmsk(ji,jk)
@@ -1075,6 +1225,11 @@
          ! ... jpjsob,(jpisdp1, jpisfm1)
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          ! ... 2* j-gradient of u (f-point i=nibm, time mean)
                   z2dx = (- usbnd(ji,jk,nibm ,nit) - usbnd(ji,jk,nibm ,nitm2) &
@@ -1132,6 +1287,11 @@
          ! ... jpjsob,(jpisdp1,jpisfm1)
          DO jj = fs_njs0, fs_njs1 ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          ! ... 2* gradj(v) (T-point i=nibm, time mean)
                   z2dx = ( - vsbnd(ji,jk,nibm ,nit) - vsbnd(ji,jk,nibm ,nitm2) &
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 3211)
@@ -20,4 +20,9 @@
    PUBLIC   obc_rst_read    ! routine called by obc_ini
    PUBLIC   obc_rst_write   ! routine called by step
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90	(revision 3211)
@@ -43,4 +43,9 @@
       rtauein, rtauwin, rtaunin, rtausin      ! Boundary restoring coefficient for inflow 
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "obc_vectopt_loop_substitute.h90"
@@ -140,7 +145,13 @@
 
       IF( ( kt < nit000+3 .AND. .NOT.ln_rstart ) .OR. lfbceast ) THEN
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ta(ji,jj,jk) = ta(ji,jj,jk) * (1. - temsk(jj,jk)) + &
                                  tfoe(jj,jk)*temsk(jj,jk)
@@ -178,7 +189,13 @@
          !     tial velocity (here vn), which have been saved in (u_cxebnd,v_cxebnd)
          ! ... (jpjedp1, jpjefm1), jpieob+1
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_nie0+1, fs_nie1+1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... i-phase speed ratio (from averaged of v_cxebnd)
                   z05cx = ( 0.5 * ( v_cxebnd(jj,jk) + v_cxebnd(jj-1,jk) ) ) / e1t(ji-1,jj)
@@ -241,7 +258,13 @@
       IF( ( kt < nit000+3 .AND. .NOT.ln_rstart ) .OR. lfbcwest ) THEN
 
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_niw0, fs_niw1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ta(ji,jj,jk) = ta(ji,jj,jk) * (1. - twmsk(jj,jk)) + &
                                  tfow(jj,jk)*twmsk(jj,jk)
@@ -278,7 +301,13 @@
          ! ... the phase velocity is taken as the phase velocity of the tangen-
          ! ... tial velocity (here vn), which have been saved in (v_cxwbnd)
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = fs_niw0, fs_niw1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
+#endif
          ! ... i-phase speed ratio (from averaged of v_cxwbnd)
                   z05cx = (  0.5 * ( v_cxwbnd(jj,jk) + v_cxwbnd(jj-1,jk) ) ) / e1t(ji+1,jj)
@@ -341,6 +370,11 @@
 
          DO jj = fs_njn0+1, fs_njn1+1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   ta(ji,jj,jk)= ta(ji,jj,jk) * (1.-tnmsk(ji,jk)) + &
                                 tnmsk(ji,jk) * tfon(ji,jk)
@@ -379,6 +413,11 @@
          ! ... jpjnob+1,(jpindp1, jpinfm1)
          DO jj = fs_njn0+1, fs_njn1+1 ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          ! ... j-phase speed ratio (from averaged of vtnbnd)
          !        (bounded by 1)
@@ -443,6 +482,11 @@
 
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   ta(ji,jj,jk)= ta(ji,jj,jk) * (1.-tsmsk(ji,jk)) + &
                                 tsmsk(ji,jk) * tfos(ji,jk)
@@ -480,6 +524,11 @@
          !... jpjsob,(jpisdp1, jpisfm1)
          DO jj = fs_njs0, fs_njs1  ! Vector opt.
+#if defined key_z_first
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
          !... j-phase speed ratio (from averaged of u_cysbnd)
          !       (bounded by 1)
